<template>
  <q-page class="column items-center justify-center">
    <div id="realtime_plot" style="width: 100%; height: 500px"></div>
    <div class="row items-center justify-center" style="width: 100%">
      <div
        class="column items-center justify-center"
        v-for="(header, index) in headers.slice(1)"
        :key="'header-toggle' + index"
      >
        <line-button-vue
          flat
          :color="colors[index]"
          :label="header"
          :visible="visibility_table[index]"
          @toggled="toggleLine(index)"
          class="col-1"
        />
        <!-- <q-btn round icon="mdi-playlist-remove" text-color="primary" @click="clear_plot" /> -->
        <span
          class="col-1"
          :style="{ color: colors[index] }"
        >
          {{ displayed_data.slice(1)[index]?.toFixed(3) }}
        </span>
      </div>
    </div>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, Ref, ref, onMounted } from 'vue';
import Dygraph from 'dygraphs';
import LineButtonVue from 'components/plot/LineButton.vue';

export default defineComponent({
  name: 'Plot',
  components: {
    LineButtonVue,
  },
  setup() {
    let plot: Dygraph | null = null;
    const colors = ['#ca6037', '#717ccd', '#75ab3d', '#bd5db0', '#54a77b', '#cc566c', '#b49242'];
    const visibility_table: Ref<Array<boolean>> = ref([]);
    const data: Ref<Array<Array<number>>> = ref([]);
    const headers: Ref<Array<string>> = ref([]);
    const displayed_data: Ref<Array<number>> = ref([]);
    const time_index_absolute = ref(0);

    const initPlot = () => {
      plot = new Dygraph('realtime_plot', [], {
        labels: [],
        colors: colors,
        strokeWidth: 2.0,
      });
      // show the plot
      setTimeout(() => {
        plot?.resize();
      }, 100);
    };

    const updateLabels = (header: Array<string>) => {
      // note: time should be the first element
      const time_index = header.indexOf('t');
      if (time_index > -1) {
        const time_string = header.splice(time_index, 1);
        header = time_string.concat(header);
        time_index_absolute.value = time_index;
      } else {
        // A counter is used instead of the time value for the x axis
        header = ['Time'].concat(header);
        time_index_absolute.value = 0;
      }
      plot?.updateOptions({
        labels: header,
      });
      headers.value = header;
      visibility_table.value = plot ? plot.visibility() : Array<boolean>(header.length - 1);
      counter.value = 0;
      data.value.splice(0);
    };

    const counter = ref(0);

    const updateData = (values: Array<number>) => {
      const time_index = time_index_absolute.value;
      if (time_index > -1) {
        const time_value = values.splice(time_index, 1);
        values = time_value.concat(values);
      } else {
        values = [counter.value].concat(values);
      }
      data.value.push(values);
      displayed_data.value = values;
      data.value.splice(0, Math.max(0, data.value.length - 2000));
      plot?.updateOptions({
        file: data.value,
      });
      counter.value += 1;
    };

    const toggleLine = (index: number) => {
      visibility_table.value[index] = !visibility_table.value[index];
      plot?.setVisibility(index, visibility_table.value[index]);
    };

    const clear_plot = () => {
      data.value.splice(0);
    };

    onMounted(() => {
      initPlot();
      void window.log.onData(updateData);
      void window.log.onHeaders(updateLabels);
      void window.log.initPlot().then((res) => updateLabels(res));
    });

    return {
      headers,
      colors,
      toggleLine,
      visibility_table,
      clear_plot,
      displayed_data,
    };
  },
});
</script>

<style lang="sass" scoped>
.card
  width: 100%
  max-width: 400px
  height: 100%
  height: 350px
  padding: 6px
  cursor: pointer
  transition: all .25s ease-in-out
  &:hover
    transform: scale(1.2)
</style>
